// This js handles the front end for ifthenelse ui

var container = document.querySelector('#rete');
var editor = new Rete.NodeEditor('demo@0.1.0', container);
editor.use(ConnectionPlugin.default);
editor.use(VueRenderPlugin);
editor.use(ContextMenuPlugin);
editor.use(AreaPlugin);
editor.use(CommentPlugin);
editor.use(HistoryPlugin);

var engine = new Rete.Engine('demo@0.1.0');

(function ($, Drupal, drupalSettings) {
	$(document).ready(function(){
		//If it is a new add rule page than this variable value will be false and it will trigger
		// a new retejs generation.
		if(!drupalSettings.ifthenelserule.data){
			(async () => {
				editor.on('process nodecreated noderemoved connectioncreated connectionremoved', async () => {
						await engine.abort();
						await engine.process(editor.toJSON());
						//setting value of rule data from retejs graph
						jQuery('#ifthenelse-data').val(JSON.stringify(editor.toJSON()));
						//console.log(editor.toJSON());

						//Hardcoded rule event to form alter.
						//@todo: Make this dynamic based on what event node is added.
						jQuery('#ifthenelse-event').val('form_alter');
				});
		
				setTimeout(function(){ editor.view.resize(); }, 500);
				editor.view.resize();
				AreaPlugin.zoomAt(editor);
				editor.trigger('process');
		
			})();
		}else{
			//If it is a rule edit form than build the rete graph from saved data
			editor.fromJSON(JSON.parse(drupalSettings.ifthenelserule.data))
			.then(() => {
				editor.on("error", err => {
					alertify.error(err.message);
				});
		
				editor.on(
					"process connectioncreated connectionremoved nodecreated",
					async function() {
						if (engine.silent) return;
						onMessageTask = [];
						await engine.abort();
						await engine.process(editor.toJSON());
						//setting value of rule data from retejs graph
						jQuery('#ifthenelse-data').val(JSON.stringify(editor.toJSON()));
						//console.log(editor.toJSON());

						//Hardcoded rule event to form alter.
						//@todo: Make this dynamic based on what event node is added.
						jQuery('#ifthenelse-event').val('form_alter');
					}
				);
		
				editor.trigger("process");
				editor.view.resize();
				AreaPlugin.zoomAt(editor);
			});
		}
	});
	
	
})(jQuery, Drupal, drupalSettings);