<?php

namespace Drupal\if_then_else\Controller;

use Drupal\Component\Utility\Html;

/**
 * IftheneelseRule module controller class to define url callbacks.
 */
class ReteIntegration {

  /**
   * Ajax Url route callback to fetch fields of forms.
   */
  public function fetchFields() {
    $listFields = [];
    $post_data = json_decode(file_get_contents('php://input'), TRUE);

    // Calling ifthenelse utilities service.
    $ifthenelseUtilities = \Drupal::service('ifthenelse.utilities');

    if (isset($post_data['type']) && $post_data['type'] == 'entity_bundle' && isset($post_data['entity']) && isset($post_data['bundle'])) {
      $entity_type_id = Html::escape($post_data['entity']);
      $entity_bundle = Html::escape($post_data['bundle']);

      // Get list of fields by entity and bundle id.
      $listFields = $ifthenelseUtilities->getFieldsByEntityBundleId($entity_type_id, $entity_bundle);
    }
    elseif (isset($post_data['type']) && $post_data['type'] == 'other_form_class') {
      $form_class = Html::escape($post_data['form_class']);
      // Get List of fields by Form class.
      $listFields = $ifthenelseUtilities->getFieldsByFormClass($form_class);
    }

    echo json_encode($listFields);
    exit();
  }

  /**
   * Ajax Url route callback to fetch fields of forms.
   */
  public function fetchFieldInfo() {

    $post_data = json_decode(file_get_contents('php://input'), TRUE);

    // Calling ifthenelse utilities service.
    $ifthenelseUtilities = \Drupal::service('ifthenelse.utilities');

    if (isset($post_data['entity']) && isset($post_data['bundle']) && isset($post_data['field_name'])) {
      $entity_type_id = Html::escape($post_data['entity']);
      $entity_bundle = Html::escape($post_data['bundle']);
      $field_name = Html::escape($post_data['field_name']);

      // Get list of fields by entity and bundle id.
      $listFields = $ifthenelseUtilities->getFieldInfoByEntityBundleId($entity_type_id, $entity_bundle, $field_name);
    }

    echo json_encode($listFields);
    exit();
  }

}
