<?php

namespace Drupal\if_then_else\Entity;

use Drupal\Core\Config\Entity\ConfigEntityBase;

/**
 * Class defined for IfthenelseRule entity.
 *
 * @ConfigEntityType(
 *   id ="ifthenelserule",
 *   label = @Translation("Ifthenelse Rule"),
 *   config_prefix = "ifthenelserule",
 *   handlers = {
 *     "list_builder" = "Drupal\if_then_else\IfthenelseRuleListBuilder",
 *     "form" = {
 *       "add" = "Drupal\if_then_else\IfthenelseRuleForm",
 *       "edit" = "Drupal\if_then_else\IfthenelseRuleForm",
 *       "delete" = "Drupal\Core\Entity\EntityDeleteForm"
 *     }
 *   },
 *   entity_keys = {
 *     "id" = "id",
 *     "label" = "label",
 *     "weight" = "weight"
 *   },
 *   links = {
 *     "delete-form" = "/admin/config/system/ifthenelse/manage/{ifthenelserule}/delete",
 *     "edit-form" = "/admin/config/system/ifthenelse/manage/{ifthenelserule}",
 *     "collection" = "/admin/config/system/ifthenelse-rules",
 *   },
 *   config_export = {
 *     "id",
 *     "label",
 *     "active",
 *     "module",
 *     "event",
 *     "data",
 *     "weight",
 *   }
 * )
 */
class IfthenelseRule extends ConfigEntityBase implements IfthenelseRuleInterface {

  /**
   * The announcement's message.
   *
   * @var string
   */
  protected $rules;

  /**
   * Ifthenelse rule ID.
   *
   * @var string
   */
  public $id;

}
