var VueEventTriggerControl = {
  props: ['getData', 'putData'],
  data(){
    return drupalSettings.ifthenelserule.nodes.formAlterEvent
  },
  template: '',
  mounted(){
    // initialize variable for data
    this.putData('type',drupalSettings.ifthenelserule.nodes.formAlterEvent.type);
    this.putData('class',drupalSettings.ifthenelserule.nodes.formAlterEvent.class);
    this.putData('event_name',drupalSettings.ifthenelserule.nodes.formAlterEvent.name);
  }
}

class EventTriggerControl extends Rete.Control {

  constructor(emitter, key, readonly) {
    super(key);
    this.component = VueEventTriggerControl;
  }

}

class EventComponent extends Rete.Component {

  constructor(){
      super("Event: Form Load");
  }

  //Event node builder
  builder(node) {
      //creating output socket
      var formOutput = new Rete.Output('form', "", formObjectSocket);
      var formStateOutput = new Rete.Output('formState', "", formStateSocket);

      return node.addControl(new EventTriggerControl(this.editor, 'event')).addOutput(formOutput).addOutput(formStateOutput);
  }

  worker(node, inputs, outputs) {
      outputs['form'] = node.data.event;
  }
}

var components = [new EventComponent()];	

components.map(c => {
  editor.register(c);
  engine.register(c);
});