<?php

namespace Drupal\if_then_else\core\Events\HookFormAlterEvent;

/**
 * Hook form alter event node class.
 */
class HookFormAlterEvent {

  /**
   * All node Inputs.
   *
   * @var array
   */
  private $inputs;

  /**
   * All node Outputs.
   *
   * @var array
   */
  private $output;

  /**
   * Current node object data.
   *
   * @var array
   */
  private $data;

  /**
   * Ifthenelserule constructor.
   *
   * @param object $data
   *   Node object.
   */
  public function __construct($data) {
    $this->data = $data;
  }

  /**
   * Function to set inputs.
   *
   * @param array $inputs
   *   Array of all inputs to node.
   */
  public function setInputs(array $inputs) {
    $this->inputs = $inputs;
  }

  /**
   * Get node output.
   *
   * @return output
   *   Returns output of current node set by process function.
   */
  public function getOutput() {
    return $this->output;
  }

  /**
   * Process inputs and set output.
   */
  public function process() {
    $this->output['form'] = &$this->inputs['form'];
    $this->output['formState'] = $this->inputs['formState'];
  }

}
