<?php

namespace Drupal\if_then_else\core;

/**
 * Class defined to process event type of rete nodes.
 */
class IfthenelseEvent implements IfthenelseEventInterface {

  /**
   * {@inheritdoc}
   */
  public function eventPresent($event_name) {
    static $entity = '';
    $rule_events = &drupal_static(__FUNCTION__);
    if (!isset($rule_events)) {
      // Load all ifthenelserule entity.
      $storage = \Drupal::entityTypeManager()->getStorage('ifthenelserule');
      $entity = $storage->loadMultiple();
      foreach ($entity as $key => $rule) {
        // Check if the ifthenelserule entity have event defined and is active.
        if (isset($rule->event) && $rule->event == $event_name && $rule->active) {
          $data = $rule->data;
          $rule_events[$rule->event]['data'][] = json_decode($data);
          $rule_events[$rule->event]['name'] = $rule->label;
        }
      }
    }

    $rule_config = [];
    if (isset($rule_events[$event_name]) && !empty($rule_events[$event_name])) {
      $rule_config = $rule_events[$event_name];
    }

    // Return all rule config in form of array.
    return $rule_config;
  }

}
